<?php


function readContainerConfig() {
  try {
    $output = [];
    exec('basename "$(cat /proc/1/cpuset)"', $output);
    $id = reset($output);
    if ($id === '/') {
      $id = getenv('COMPOSE_PROJECT_NAME') . '_l3d';
    }
    $output = [];
    exec('docker container inspect ' . $id, $output);
    return json_decode(implode('', $output), TRUE)[0];
  }
  catch (\Exception $ex) {
    // Ignore.
  }
  return [];
}

function getDockerMountSource($args) {
  $currentDir = getcwd();
  $suffix = (empty($args[2])) ? '' : '/' . $args[2];
  $destDir = (empty($args[1])) ? $currentDir : $args[1];

  $container = readContainerConfig();
  foreach ($container['Mounts'] as $mount) {
    if (strpos($currentDir, $mount['Destination']) === 0) {
      return $mount['Source'] . $suffix . ':' . (empty($args[1]) ? $mount['Destination'] : $destDir) . $suffix;
    }
  }
  return $currentDir . $suffix . ':' . $destDir . $suffix;
}

function getAllDockerMountSources() {
  $volumes = [];
  $container = readContainerConfig();
  foreach ($container['Mounts'] as $mount) {
    $volumes[] = '-v ' . $mount['Source'] . ':' . $mount['Destination'];
  }
  return implode(' ', $volumes);
}

if ($argc === 1 || $argv[1] !== '--all') {
  print(getDockerMountSource($argv));
}
else {
  print(getAllDockerMountSources());
}
